import "CoreLibs/graphics"
import "CoreLibs/object"
import "pixie"

local gfx <const> = playdate.graphics

local defaultFont = gfx.font.new("fonts/Mini Mono")

class("TextBox").extends(gfx.sprite)

function TextBox:init(w, h, x, y, vert, align, font)
   TextBox.super.init(self)

   self:setSize(w, h)
   self:moveTo(x, y)
   self:setZIndex(999)
   self.align = align or kTextAlignment.left
   self.font = font or defaultFont
   self.vert = vert
   self.text = ""
end

function TextBox:setText(text)
   self.text = text
end

function TextBox:draw(x, y, w, h)
   gfx.pushContext()

   gfx.setColor(gfx.kColorWhite)
   gfx.fillRect(x, y, w, h)
   gfx.setColor(gfx.kColorBlack)
   gfx.drawRoundRect(x, y, w, h, 2)

   gfx.setFont(self.font)
   gfx.drawTextInRect(
      self.text,
      x, y+self.vert, w, h, nil, nil, self.align
   )

   gfx.popContext()
end

